// Ys3(PC-98:2HD)t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include "d88.h"

static unsigned char buff[0x400*8*154];			// 1024byte x 8sector x 154track
static unsigned char dir[0x400*8];
static char dirpath[FILENAME_MAX];				// 쐬fBNg

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
//	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool fsave(char *_fname, unsigned char *_pt, int _size)
{
	fp = fopen(_fname,"wb");
//	printf ("cutting ... %s\n",_fname);
	fwrite(_pt, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int mode=1;
	int diskno,numdisk,i,fn,media;
	int h;
	int s_sec,e_sec,size;

	if (argc<2 && argc>4)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}
	if (argc==3 && !strcmp(argv[2],"-d"))
	{
		mode=0;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	numdisk = disk.GetNumDisk();	// fBXNC[W
	for (diskno=0; diskno<numdisk; diskno++)
	{
		disk.SelectDisk(diskno);
		sprintf(dirpath,"%03d",diskno);		// fBNg̐
		if (mode)
		{
			_mkdir(dirpath);				// fBNg쐬
			_chdir(dirpath);				// fBNgړ
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}

		media = disk.GetDiskType();	
		if (media==disk.TYPE_2HD)
		{
			printf("2HDfBAF܂.\n");
		}
		else
		{
			fprintf(stderr, "Ή̃fBXNC[W`ł.\n");
			return 1;
		}
		disk.SetRecordRange(0x01,0x08);

		// Track 1ȍ~ۂƓǂݍ
		for (i=1; i<154; i++)
		{
			disk.ReadDATA(i, i>>1, i&1, 1, 0x03, &buff[0x400*8*i], 0x400*8);
		}
		// fBNgǂݍ
		disk.ReadDATA(0x01, 0x00, 0x01, 0x01, 0x03, dir, 0x400*8);

		for (fn=0; fn<(sizeof(dir)/0x10); fn++)
		{
			unsigned char *ent = &dir[fn*0x10];
			if (*ent == 0xff) break;	// fBNg̍Ō
			int i;
			int fnp = 0;
			for (i=0x00; i<0x06; i++)
			{
				char c = ent[i];		// t@CPo
				if (c==' ') break;
				fname[fnp++] = c;		// t@C\
			}
			fname[fnp++] = '\0';		// ̍Ō

			s_sec = *(ent+0x0c)+*(ent+0x0d)*0x100;	// Jn_ZN^
			e_sec = *(ent+0x0e)+*(ent+0x0f)*0x100;	// I_ZN^
			size  = (e_sec-s_sec+1)*0x400;			// TCYvZ

			printf("%-6s  START:%04x  END:%04x  SIZE:%04x\n",fname,s_sec,e_sec,size);
			fsave(fname, &buff[s_sec*0x400], size);
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}

